clearlistener()

mscale=39.3700787

fn align16 l =(
	while l >=16 do l=l-16
	return (16-l)
)

fn align8 l =(
	while l>=8 do l=l-8
	return (8-l)
)

fn align l pos =(
	while pos>=l do pos=pos-l
	return(l-pos)
)

struct FVECTOR (x,y,z)
struct F4VECTOR (x,y,z,w)
struct FVECTOR44 (x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,w1,w2,w3,w4)
struct TEXTURENAME (texturename)
struct MODELDATA (
    Nine, --int always 9
    CRC, --unsigned int CRC
    SizeOfModelData, --int
    SizeOfgmesh_pc, --unsigned int
    Flags, --unsigned int
    Block3Count,
    unknown2, --7 int
    IndicesCount, --int
    Unknown3, --3 int
    IndexStride, --unsigned byte 
    unknown4, --byte
    unknown5, --short
    unknown6, --int
    BonesInRigCount, --int
    unknown7, --7 int
    ModelScale, --x,y,z
    unknown8, --3 int
    VertexCount, --int
    VertexStride, --unsigned byte
    Unknown9, --unsigned byte
    unknown10, --short
    unknown11 --unsigned byte
)
modeldata = modeldata()

if SR3Importer != undefined then destroydialog SR3Importer
rollout SR3Importer "SRIII model importer V1" (
	button Pick_CC "Pick ccmesh_pc file" align:#left
	--edittext TextLoc "Texture dir:" width:100 across:2
	--button Pick_TextLoc "..." height:18
	checkbox cc_log "log" checked:true
	

	on Pick_CC pressed do (
		logg=false
		if cc_log.checked = true then logg=true
		
		ccmesh = GetOpenFileName \
		caption:"Saints Row III Importer" \
		types: "SRIII CC File (*.ccmesh_pc)|*.ccmesh_pc|"
		if (ccmesh!=undefined) AND ((doesFileExist ccmesh)==true) then(
			ccpath=getFilenamePath ccmesh
			ccname=getFilenameFile ccmesh
			ccsize=getFileSize ccmesh
			gcmesh=(ccpath+ccname+".gcmesh_pc")
			if (gcmesh!=undefined) AND ((doesFileExist gcmesh)==true) then(
				c = fopen ccmesh "rb"
				g = fopen gcmesh "rb"
				
				gcsize=getFileSize gcmesh
				modeldata.indicescount=0
				--count4=0
				
				check=true
				while check==true do( --seeking the indicescount
					if (ftell c)!=ccsize AND check==true then(
						readshort c --character T8
						readshort c --always 4 caller for texturenamelist?
						--start of texturenamelist
						SizeOfTextureNameList = readlong c
						readlong c
						TextureNameListCount = readlong c
						readlong c
						readlong c
						readlong c
						readlong c
						Texturenamelist = for i=1 to Texturenamelistcount collect readstring c
						for i=1 to (align 16 (ftell c)) do readbyte c --align to 16 bytes
						--end of texturenamelist

						--start of bones information
						readlong c --unknown always 424BD00D
						readlong c --unknown integer 42 or 41
						PointsOfInterestCount = readshort c
						NumberOfBones = readshort c
						readshort c --unknown1
						readshort c --unknown2
						readshort c -- unknnown3
						readshort c --unknown4
						for i=1 to 5 do readlong c --unknown5 integers
						BoundingSphereCentre = [readfloat c, readfloat c, readfloat c]
						BoundingSphereRadius = readfloat c
						Thing1Count = readshort c
						Thing2Count = readshort c
						for i=1 to 2 do readshort c --unknown6 short integers
						for i=1 to 18 do readlong c --unknown7 long integers
						--end of bones information

						--start of texturenamelist2
						TextureNames2Size = readlong c
						readlong c --unknown8
						for i=1 to TextureNames2Size do readbyte c--skipping texturenames2
						--end of texturenamelist2

						--start of bones data
						if Thing1Count > 0 then (
							for i=1 to (align 16 (ftell c)) do readbyte c
						)
						else (
							for i=1 to (align 8 (ftell c)) do readbyte c
						)
						for i=1 to PointsOfInterestCount do (
							readstring c
							readlong c --unknown
							poivector = [readfloat c,readfloat c, readfloat c]
							poivector4 = [readfloat c,readfloat c, readfloat c, readfloat c]
						)
						if PointsOfInterestCount > 0 then ( ---THINK OF SOMETHING HERE
							for i=1 to (align 16 (ftell c)) do readbyte c
						)
						for i=1 to Thing1Count do ( --UNKNOWN SO FAR
							readlong c --thing1block unknown1
							readlong c --thing1block unknown2
							Thing1Vector = [readfloat c, readfloat c, readfloat c]
							Thing1Float = readfloat c
							readlong c
							readlong c
						)
						for i=1 to Thing2Count do ( --PROBABLY THE BONE SIZE AND SHAPES
							readlong c --thing2block unknown1
							readlong c --thing2block unknown2
							Thing2normal = [readfloat c, readfloat c, readfloat c]
							Thing2position = [readfloat c, readfloat c, readfloat c]
							Thing2float1 = readfloat c
							Thing2float2 = readfloat c
						)
						spacing = spacing = align 16 (ftell c) --times the length of 1 Thing2Count
						for i=1 to spacing do readbyte c
						
						Bonesdata = for i=1 to numberofbones collect readlong c #signed --number of bones
						if numberofbones > 0 then (
							for i=1 to (align 8 (ftell c)) do readbyte c
						)
						--end of bones data
						
						--start of modeldata
						modeldata.Nine = readlong c --always 9
						modeldata.CRC = readlong c #unsigned
						modeldata.SizeOfModelData = readlong c
						modeldata.SizeOfgmesh_pc = readlong c #unsigned
						modeldata.Flags = readlong c #unsigned
						modeldata.Block3Count = readlong c
						modeldata.unknown2 = for i=1 to 6 collect readlong c --unknown 7 integers
						modeldata.IndicesCount = readlong c
						modeldata.unknown3 = for i=1 to 3 collect readlong c --unknown 3 integers
						modeldata.IndexStride = readbyte c #unsigned
						modeldata.unknown4 = readbyte c --unknown char1
						modeldata.unknown5 = readshort c --unknown short
						modeldata.unknown6 = readlong c --uknown integer
						modeldata.BonesInRigCount = readlong c
						modeldata.unknown7 for i=1 to 7 collect readlong c --unknown 7 integers
						modeldata.ModelScale = [readfloat c, readfloat c, readfloat c]
						modeldata.unknown8 = for i=1 to 3 collect readlong c --unknown 3 integers
						modeldata.Vertexcount = readlong c
						modeldata.VertexStride = readbyte c #unsigned
						modeldata.unknown9 = readbyte c #unsigned --unknown char
						modeldata.unknown10 = readshort c --unknown10
						modeldata.unknown11 = readbyte c #unsigned --unknown char
						--end of modeldata

						for i=1 to (align 8 (ftell c)) do readbyte c
						
						--start of bonedata
						readlong c #unsigned --unknown9
						readlong c #unsigned --unknown10
						BoneIndexes = for i=1 to modeldata.BonesInRigCount collect readbyte c #unsigned
						if modeldata.BonesInRigCount > 0 then (
							BoneInRigCheck = readbyte c #unsigned
						)
						for i=1 to (align 16 (ftell c)) do readbyte c
						
						for i=1 to modeldata.Block3Count do (
							readlong c --unknown1 in shaundy always a 6 or a 1
							for j=1 to 11 do readfloat c --unkown2
						)
						--end of bonedata

						lodarray = #()
						for i=1 to modeldata.unknown5 do (
							entry = #()
							for j=1 to 5 do append entry (readlong c)
							append lodarray entry
						)
						--print lodarray
						check=false
					)
					else(check=false)
				)
				
				--print indicesCount
				
				vertArray=#()
				uvwArray=#()
				normArray=#()
				faceArray=#()
				mtlidarray=#()
				
				--print indicescount
				
				sortedlods = #()
				sortedlodlengths = #()
				for i=1 to lodarray.count do (
					lodinfo = lodarray[i]
					id = lodinfo[1]+1
					--print id
					lodlength = (lodinfo[3] - lodinfo[2])
					if sortedlods[id] == undefined then (
						sortedlods[id] = i
						sortedlodlengths[id] = lodlength
					)
					else (
						if sortedlodlengths[id] < lodlength then (
							sortedlods[id] = i
							sortedlodlengths[id] = lodlength
						)
					)
				)
				print sortedlods

				check=true
				while check==true do( --seeking the indicescount
					if (ftell g)!=gcsize AND check==true then(
						
						readlong g #unsigned --crc of file
						for i=1 to 3 do readlong g --align16
						
						faceindices=#()
						for i=1 to modeldata.indicescount do (
							append faceindices ((readshort g #unsigned) +1)
						)
						--print faceindices.count
						--print lodarray
						
						lods = lodarray.count-1
						if lods<1 then lods=1

						for i in sortedlods do (
							element = lodarray[i]
							startindice = element[2]+1
							endindice = element[3]
							f1 = faceindices[startindice]
							f2 = faceindices[startindice+1]
							facedirection = -1
							FaceCounter = element[4]+1
							--print FaceCounter
							for k=2 to endindice-1 do (
								f3=faceindices[startindice+k]
								FaceDirection = -FaceDirection
								if (f1!=f2)AND(f2!=f3)AND(f3!=f1) then (
									if FaceDirection > 0 then (
										append faceArray [f1,f2,f3]
										append mtlidarray (element[1]+1)
									)
									else ( 
										append faceArray [f1,f3,f2]
										append mtlidarray (element[1]+1)
									)
								)
								f1 = f2
								f2 = f3
							)
						)
						--print facearray.count

						
						for i=1 to (align 16 (ftell g)) do readbyte g
						
						for i = 1 to modeldata.VertexCount do (
							p1=readfloat g * mscale
							p2=readfloat g * mscale
							p3=readfloat g * mscale
							n1 = ((readbyte g #unsigned) as float -128.0) / 128.0
							n2 = ((readbyte g #unsigned) as float -128.0) / 128.0
							n3 = ((readbyte g #unsigned) as float -128.0) / 128.0
							n4 = readbyte g
							for i=1 to (modeldata.vertexstride - 20) do (
								readbyte g
							)
							tv1 = readshort g /1024.0
							tv2 = (readshort g /1024.0)-1.0
							
							append vertArray[p1,-p3,p2]
							append uvwArray[tv1,-tv2,0]
							append normArray[n1,-n3,n2]
						)
						
						msh = mesh vertices:vertArray faces:facearray materialIDs:mtlidarray
						msh.numTVerts = vertArray.count
						buildTVFaces msh
						msh.displayByLayer = false
						msh.backfacecull = on
						for j = 1 to vertArray.count do setTVert msh j uvwArray[j]
						for j = 1 to vertArray.count do setNormal msh j normArray[j]
						for j = 1 to faceArray.count do setTVFace msh j faceArray[j]
						convertTo msh PolyMeshObject
						
						check=false
					)
					else(check=false)
				)

				fclose c
				fclose g
			)
			else(messagebox "ERROR!!\nFile Pair Wasn't Found")
		)
		else(Print "Aborted.")
	)
)
createdialog SR3Importer

